/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TARMUNIDADTIPO")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tarmunidadtipo.findAll", query = "SELECT t FROM Tarmunidadtipo t"),
    @NamedQuery(name = "Tarmunidadtipo.findByClase", query = "SELECT t FROM Tarmunidadtipo t WHERE t.tarmunidadtipoPK.clase = :clase"),
    @NamedQuery(name = "Tarmunidadtipo.findByClasecode", query = "SELECT t FROM Tarmunidadtipo t WHERE t.tarmunidadtipoPK.clasecode = :clasecode"),
    @NamedQuery(name = "Tarmunidadtipo.findByTipoarmaexplosivo", query = "SELECT t FROM Tarmunidadtipo t WHERE t.tarmunidadtipoPK.tipoarmaexplosivo = :tipoarmaexplosivo"),
    @NamedQuery(name = "Tarmunidadtipo.findByTipoarmaexplosivocodigo", query = "SELECT t FROM Tarmunidadtipo t WHERE t.tarmunidadtipoPK.tipoarmaexplosivocodigo = :tipoarmaexplosivocodigo"),
    @NamedQuery(name = "Tarmunidadtipo.findByUnidadmedidapeso", query = "SELECT t FROM Tarmunidadtipo t WHERE t.tarmunidadtipoPK.unidadmedidapeso = :unidadmedidapeso"),
    @NamedQuery(name = "Tarmunidadtipo.findByUnidadmedidapesocodigo", query = "SELECT t FROM Tarmunidadtipo t WHERE t.tarmunidadtipoPK.unidadmedidapesocodigo = :unidadmedidapesocodigo"),
    @NamedQuery(name = "Tarmunidadtipo.findByRecordversion", query = "SELECT t FROM Tarmunidadtipo t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tarmunidadtipo.findByFecharegistro", query = "SELECT t FROM Tarmunidadtipo t WHERE t.fecharegistro = :fecharegistro")})
public class Tarmunidadtipo implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TarmunidadtipoPK tarmunidadtipoPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "FECHAREGISTRO")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecharegistro;
    @OneToMany(mappedBy = "tarmunidadtipo")
    private Collection<Tarmtipoarmaexplosivo> tarmtipoarmaexplosivoCollection;
    @OneToMany(mappedBy = "tarmunidadtipo")
    private Collection<Tarmcomerciantecupo> tarmcomerciantecupoCollection;
    @JoinColumns({
        @JoinColumn(name = "TIPOARMAEXPLOSIVO", referencedColumnName = "CATALOG", insertable = false, updatable = false),
        @JoinColumn(name = "TIPOARMAEXPLOSIVOCODIGO", referencedColumnName = "CATALOGCODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgenecatalogdetail tgenecatalogdetail;
    @JoinColumns({
        @JoinColumn(name = "CLASE", referencedColumnName = "CATALOG", insertable = false, updatable = false),
        @JoinColumn(name = "CLASECODE", referencedColumnName = "CATALOGCODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgenecatalogdetail tgenecatalogdetail1;
    @JoinColumns({
        @JoinColumn(name = "UNIDADMEDIDAPESO", referencedColumnName = "CATALOG", insertable = false, updatable = false),
        @JoinColumn(name = "UNIDADMEDIDAPESOCODIGO", referencedColumnName = "CATALOGCODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgenecatalogdetail tgenecatalogdetail2;
    @OneToMany(mappedBy = "tarmunidadtipo")
    private Collection<Tarmtotalpersona> tarmtotalpersonaCollection;

    public Tarmunidadtipo() {
    }

    public Tarmunidadtipo(TarmunidadtipoPK tarmunidadtipoPK) {
        this.tarmunidadtipoPK = tarmunidadtipoPK;
    }

    public Tarmunidadtipo(String clase, String clasecode, String tipoarmaexplosivo, String tipoarmaexplosivocodigo, String unidadmedidapeso, String unidadmedidapesocodigo) {
        this.tarmunidadtipoPK = new TarmunidadtipoPK(clase, clasecode, tipoarmaexplosivo, tipoarmaexplosivocodigo, unidadmedidapeso, unidadmedidapesocodigo);
    }

    public TarmunidadtipoPK getTarmunidadtipoPK() {
        return tarmunidadtipoPK;
    }

    public void setTarmunidadtipoPK(TarmunidadtipoPK tarmunidadtipoPK) {
        this.tarmunidadtipoPK = tarmunidadtipoPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public Date getFecharegistro() {
        return fecharegistro;
    }

    public void setFecharegistro(Date fecharegistro) {
        this.fecharegistro = fecharegistro;
    }

    @XmlTransient
    public Collection<Tarmtipoarmaexplosivo> getTarmtipoarmaexplosivoCollection() {
        return tarmtipoarmaexplosivoCollection;
    }

    public void setTarmtipoarmaexplosivoCollection(Collection<Tarmtipoarmaexplosivo> tarmtipoarmaexplosivoCollection) {
        this.tarmtipoarmaexplosivoCollection = tarmtipoarmaexplosivoCollection;
    }

    @XmlTransient
    public Collection<Tarmcomerciantecupo> getTarmcomerciantecupoCollection() {
        return tarmcomerciantecupoCollection;
    }

    public void setTarmcomerciantecupoCollection(Collection<Tarmcomerciantecupo> tarmcomerciantecupoCollection) {
        this.tarmcomerciantecupoCollection = tarmcomerciantecupoCollection;
    }

    public Tgenecatalogdetail getTgenecatalogdetail() {
        return tgenecatalogdetail;
    }

    public void setTgenecatalogdetail(Tgenecatalogdetail tgenecatalogdetail) {
        this.tgenecatalogdetail = tgenecatalogdetail;
    }

    public Tgenecatalogdetail getTgenecatalogdetail1() {
        return tgenecatalogdetail1;
    }

    public void setTgenecatalogdetail1(Tgenecatalogdetail tgenecatalogdetail1) {
        this.tgenecatalogdetail1 = tgenecatalogdetail1;
    }

    public Tgenecatalogdetail getTgenecatalogdetail2() {
        return tgenecatalogdetail2;
    }

    public void setTgenecatalogdetail2(Tgenecatalogdetail tgenecatalogdetail2) {
        this.tgenecatalogdetail2 = tgenecatalogdetail2;
    }

    @XmlTransient
    public Collection<Tarmtotalpersona> getTarmtotalpersonaCollection() {
        return tarmtotalpersonaCollection;
    }

    public void setTarmtotalpersonaCollection(Collection<Tarmtotalpersona> tarmtotalpersonaCollection) {
        this.tarmtotalpersonaCollection = tarmtotalpersonaCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tarmunidadtipoPK != null ? tarmunidadtipoPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tarmunidadtipo)) {
            return false;
        }
        Tarmunidadtipo other = (Tarmunidadtipo) object;
        if ((this.tarmunidadtipoPK == null && other.tarmunidadtipoPK != null) || (this.tarmunidadtipoPK != null && !this.tarmunidadtipoPK.equals(other.tarmunidadtipoPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tarmunidadtipo[ tarmunidadtipoPK=" + tarmunidadtipoPK + " ]";
    }
    
}
